﻿using System;
using System.Collections.Generic;
using JetBrains.Annotations;
using Magify.Model;
using UniRx;
using UnityEngine;

namespace Magify
{
    internal class SegmentationsCollection : IContextListener
    {
        [NotNull]
        private static readonly MagifyLogger _logger = MagifyLogger.Get();

        [NotNull]
        private readonly ReactiveProperty<IReadOnlyList<string>> _values = new(Array.Empty<string>());

        [NotNull]
        public IReadOnlyReactiveProperty<IReadOnlyList<string>> Values => _values;

        public ConfigScope SuitableScope => ConfigScope.Segmentations;

        public void UpdateContext(CampaignsContext context, ContextKind kind)
        {
            switch (kind)
            {
                case ContextKind.Default:
                    // ignore: might be received only from remote context
                    break;
                case ContextKind.Saved or ContextKind.Downloaded:
                    _values.Value = context.Segmentations ?? Array.Empty<string>();
                    _logger.Log($"Parsed segmentation list is: {string.Join('\n', _values.Value)}");
                    break;
            }
        }
    }
}